/*
//        var URI = cur.directoryProperties.URI;
const kPersonalAddressbookURI = "moz-abmdbdirectory://abook.mab";
const kCollectedAddressbookURI = "moz-abmdbdirectory://history.mab";
*/

var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
var directory = rdf.GetResource("moz-abdirectory://").QueryInterface(Components.interfaces.nsIAbDirectory);


function saveMabFile(mabName, mabFile, directory, filename)
{
    var directoryService =  Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
    var profileFolder = directoryService.get('ProfD',  Components.interfaces.nsIFile);
    var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
    var localMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
    localMabFile.appendRelativePath( mabFile );

    if (!filename)
      filename = mabName.replace( /\s|\./g, "_" )+".mab";
    try {
      var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      file.initWithFile( directory );
      file.appendRelativePath( filename );
//TODO: eventuell umbenennen statt lschen
      if (file.exists()) { file.remove(true); }
      localMabFile.copyTo( directory, filename );
        //creates directory, if not existing!
    } catch(e) { return false; }
    return true;
} //

function loadMabFile(create, mabName, mabFile, directory, filename)
{
    if (!filename) { // sync load
      filename = mabName.replace( /\s|\./g, "_" )+".mab";
      var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      file.initWithFile( directory );
      file.appendRelativePath( filename );
    } else {  // single load
      var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath( filename );
    }
    if (!file.exists()) {
      alert(strings.getString('nofile'));
      return false;
    }

    if (!create)
      deleteAddressBook( mabName, mabFile );

/*
    if( localMabFile.exists() )
      try{localMabFile.remove(false);}
      //ohne deleteAddressBook kein lschen des Files mglich!
      catch(e) {alert('file remove failed:'+e.result); return false; }

    file.copyTo( profileDir, mabFile );
*/
    var abData=readMabData(file, false);
    if (!abData) {
      alert(strings.getString('readerror'));
      return false;
    }
    writeMabData(mabFile, true, abData);

    createAddressBook( mabName, mabFile );
    return true;
}


function syncedAddressbooks()
{
  // get addressbooks to be synced, always ignore history and pab
  var mabFiles=new Array();
  var cn = directory.childNodes;
  var aBook = cn.getNext();
  while( aBook != null )
  {
      var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
      var file = cur.directoryProperties.fileName;
      var dirType = cur.directoryProperties.dirType;
      var sync=0;
      var prefName = cur.directoryProperties.prefName;
      try { sync = pref.getBoolPref( prefName+".extensions.addressbookssync" ); } catch(e) { sync=0; }
      if (file!='abook.mab' &&            // dont sync pab
          file!='history.mab' &&          // dont sync history
          dirType==2 &&                   // only normal addressbooks
          sync ) {
        mabFiles.push(file);
      }
      try { aBook = cn.getNext(); } catch(e) { break; }
  } // while
  return mabFiles;
}

function createAddressBook( name, fileName )
{
    var abProps = Components.classes["@mozilla.org/addressbook/properties;1"].createInstance(Components.interfaces.nsIAbDirectoryProperties);
    abProps.description = name;
    abProps.dirType = 2;
    abProps.fileName = fileName;
    directory.createNewDirectory( abProps );
      //for pab and history, this will create a second addressbook, because we
      //were not able to delete it. But the second addressbook ist not available
      //via getAddressBook (see below)
    var cur=getAddressBook(fileName);
    pref.setBoolPref( cur.directoryProperties.prefName+".extensions.addressbookssync", true );
} // createAddressBook

function deleteAddressBook( name, fileName )
{
// its not possible to delete the history or pab
// its not even possible to delete a second addressbook, which also referes to history.mab or abook.mab
// its not even possible to delete the preferences branch of such an addressbook !!!
  var cur=getAddressBook(fileName);
  if (cur && cur.directoryProperties.fileName!='history.mab' && cur.directoryProperties.fileName!='abook.mab') {
      var prefName = cur.directoryProperties.prefName;
        //prefName='ldap_2.servers.name' mit name='history', 'pab' oder eigener
      directory.deleteDirectory( cur );
      pref.deleteBranch( prefName );
  }
} // deleteAddressBook

function modifyAddressBook( name, fileName, newFileName )
{
/*
    var cur=getAddressBook(fileName);
    var abProps = Components.classes["@mozilla.org/addressbook/properties;1"].createInstance(Components.interfaces.nsIAbDirectoryProperties);
    abProps.description = name;
    abProps.dirType = 2;
    abProps.fileName = fileName;
    if (newFileName) abProps.fileName = newFileName; //cur.directoryProperties.fileName=newFileName;
    if (cur) {
//does not work!?
      directory.modifyDirectory( cur, abProps );
    }
*/
//TODO::
/*
    deleteAddressBook( name, fileName );
    createAddressBook( name, fileName );
*/
} // modifyAddressBook

function getAddressBook( fileName )
{
    var cn = directory.childNodes;
    var aBook = cn.getNext();
    while( aBook != null )
    {
        var cur = aBook.QueryInterface(Components.interfaces.nsIAbDirectory);
          // Liefert leider fr alle (z.b. Pers. Addressbooks) dasselbe :-(( (also z.B. immer 'pab'
/*
        var prefName = cur.directoryProperties.prefName;
        var lprefName = prefName.substr( prefName.lastIndexOf(".")+1 );
//Probably we should do something like:
// var selectedABURI = GetSelectedDirectory();
// var canRename = (selectedABURI != kCollectedAddressbookURI && selectedABURI != kPersonalAddressbookURI);
        if( lprefName != 'history' && lprefName != 'pab' && cur.directoryProperties.fileName == fileName )
*/
        if( cur.directoryProperties.fileName == fileName )
            return cur;
//if (fileName=='abook.mab') alert('skipped '+lprefName);
        try { aBook = cn.getNext(); } catch(e) { break; } // catch
    } // while
    return null;
} // getAddressBook

function getSyncURI()
{
  var syncprotocol;
  var synchost='';
  var syncuser='';
  var syncpassword='';
  var syncpath='';
  try{ syncprotocol = pref.getCharPref( "extensions.addressbookssync.protocol" ); } catch(e){}
  try{ synchost = pref.getCharPref( "extensions.addressbookssync.host" ); } catch(e){}
  try{ syncuser = pref.getCharPref( "extensions.addressbookssync.user" ); } catch(e){}
  try{ syncpassword = get_password(synchost, syncuser); } catch(e){}
  try{ syncpath = pref.getCharPref( "extensions.addressbookssync.path" ); } catch(e){}

  if( ! synchost )
    return "";
  var userpass=syncuser +((syncpassword)? ":":"")+syncpassword;
  if(userpass)
    userpass += "@";
  return syncprotocol + "://" + userpass + synchost + syncpath+'/';
}

function getTimeStamp()
{
    var date = new Date();
    return Math.floor( date.getTime() / 1000 );

} // getTimeStamp





function errorstr(aError)
{
  var error;
  switch(aError){
    case 0x804b000d:
      error='protocol not available';
      break;
    case 0x804b001e:
      error='host not found';
      break;
    case 0x80004005:
    case 405:
      error='illegal path';
      break;
    case 0x804b0015:
    case 401:
      error='illegal credentials';
      break;
    case 0x804b0016:
      error=strings.getString('nofile');
      break;
    case 0:
    case 201:
      error=strings.getString('ok');
      break;
    default:
      error='Error '+aError;
      break;
  }
  return error;
}

function onUnload()
{
  var autoupload;
  try{ autoupload = pref.getBoolPref( "extensions.addressbookssync.autoupload" ); }
    catch(e){ autoupload = false; }
  if (autoupload)
    window.open("chrome://addressbookssync/content/upload.xul","_blank","chrome,resizable,titlebar=no");
}

function onLoad()
{

  var autodownload;
  try{ autodownload = pref.getBoolPref( "extensions.addressbookssync.autodownload" ); } catch(e){ autodownload = false; }
  if (autodownload)
    window.open("chrome://addressbookssync/content/download.xul","_blank","chrome,resizable,titlebar=no");
}

function readMabData(mabFile, thunderbird)
{
  if (thunderbird) {
    var directoryService =  Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
    var profileFolder = directoryService.get('ProfD',  Components.interfaces.nsIFile);
    var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
    var nsIMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
    nsIMabFile.appendRelativePath( mabFile );
  } else
    nsIMabFile=mabFile;
  if (!nsIMabFile.exists()) return '';

  var fs = Components.classes['@mozilla.org/network/file-input-stream;1']
          .createInstance(Components.interfaces.nsIFileInputStream);
  var ss = Components.classes['@mozilla.org/scriptableinputstream;1']
          .createInstance(Components.interfaces.nsIScriptableInputStream);
  try{
    fs.init(nsIMabFile, 0x01, 0000, false);
    ss.init(fs);
    var str = ss.read(-1);
    ss.close();
    fs.close();
    return str;
  }catch(e){alert(e);}
  return "";
}

function writeMabData(mabFile, thunderbird, abData)
{
  if (thunderbird) {
    var directoryService =  Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
    var profileFolder = directoryService.get('ProfD',  Components.interfaces.nsIFile);
    var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
    var nsIMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
    nsIMabFile.appendRelativePath( mabFile );
 } else
    nsIMabFile=mabFile;
  var output=Components.classes['@mozilla.org/network/file-output-stream;1']
             .createInstance(Components.interfaces.nsIFileOutputStream);
  var input = Components.classes["@mozilla.org/io/string-input-stream;1"]
            .createInstance(Components.interfaces.nsIStringInputStream);
  input.setData(abData, -1);
  var length=input.available();
  input.close();
  output.init(nsIMabFile, 0x20|0x02|0x08, 0666, 0);//20:truncate, 2:wronly, 8:createfile
  output.write(abData, length);
  output.close();

}
